/*
Copyright or © or CCopr. INRIA : Arnaud FONTAINE

arnaud.fontaine@lifl.fr

This software is a computer program whose purpose is to predict 
significantly conserved protein coding sequences and/or RNA structure 
on a set of unaligned nucleic sequences.

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

#include "my_needlep_matrices.h"

blosum_matrix_t blosumn = {
   {6, -2, -2, -3, -2, -1, -2, -1, -3, -3, -3, -2, -2, -4, -1, 1, -1, -4, -4, -1, -3, -2, -1, -7},
   {-2, 7, -1, -3, -6, 0, -2, -4, -1, -5, -4, 2, -3, -4, -3, -2, -2, -5, -4, -4, -2, -1, -2, -7},
   {-2, -1, 7, 1, -4, -1, -1, -2, 0, -5, -5, -1, -4, -5, -4, 0, -1, -6, -4, -4, 4, -1, -2, -7},
   {-3, -3, 1, 7, -6, -2, 1, -3, -2, -6, -6, -2, -5, -5, -3, -2, -2, -7, -5, -5, 4, 0, -3, -7},
   {-2, -6, -4, -6, 9, -5, -7, -5, -6, -2, -3, -5, -3, -3, -5, -2, -2, -5, -4, -2, -5, -6, -4, -7},
   {-1, 0, -1, -2, -5, 7, 1, -4, 0, -4, -3, 1, -1, -4, -2, -1, -2, -4, -3, -4, -1, 4, -2, -7},
   {-2, -2, -1, 1, -7, 1, 6, -4, -1, -5, -5, 0, -4, -5, -3, -1, -2, -5, -4, -4, 0, 5, -2, -7},
   {-1, -4, -2, -3, -5, -4, -4, 6, -4, -6, -6, -3, -5, -5, -4, -1, -3, -5, -6, -5, -2, -4, -3, -7},
   {-3, -1, 0, -2, -6, 0, -1, -4, 9, -5, -4, -2, -3, -3, -4, -2, -3, -4, 1, -5, -1, -1, -3, -7},
   {-3, -5, -5, -6, -2, -4, -5, -6, -5, 6, 1, -4, 1, -1, -5, -4, -2, -4, -3, 2, -5, -5, -2, -7},
   {-3, -4, -5, -6, -3, -3, -5, -6, -4, 1, 5, -4, 2, 0, -5, -4, -3, -4, -3, 0, -5, -4, -2, -7},
   {-2, 2, -1, -2, -5, 1, 0, -3, -2, -4, -4, 6, -2, -4, -2, -1, -2, -6, -4, -4, -1, 0, -2, -7},
   {-2, -3, -4, -5, -3, -1, -4, -5, -3, 1, 2, -2, 8, -1, -4, -3, -2, -2, -3, 0, -5, -3, -2, -7},
   {-4, -4, -5, -5, -3, -4, -5, -5, -3, -1, 0, -4, -1, 7, -5, -4, -3, 0, 3, -2, -5, -5, -3, -7},
   {-1, -3, -4, -3, -5, -2, -3, -4, -4, -5, -5, -2, -4, -5, 8, -2, -3, -5, -5, -4, -4, -3, -3, -7},
   {1, -2, 0, -2, -2, -1, -1, -1, -2, -4, -4, -1, -3, -4, -2, 6, 1, -4, -3, -3, -1, -1, -1, -7},
   {-1, -2, -1, -2, -2, -2, -2, -3, -3, -2, -3, -2, -2, -3, -3, 1, 6, -5, -3, -1, -2, -2, -1, -7},
   {-4, -5, -6, -7, -5, -4, -5, -5, -4, -4, -4, -6, -2, 0, -5, -4, -5, 11, 1, -3, -6, -4, -4, -7},
   {-4, -4, -4, -5, -4, -3, -4, -6, 1, -3, -3, -4, -3, 3, -5, -3, -3, 1, 8, -3, -4, -4, -3, -7},
   {-1, -4, -4, -5, -2, -4, -4, -5, -5, 2, 0, -4, 0, -2, -4, -3, -1, -3, -3, 5, -5, -4, -2, -7},
   {-3, -2, 4, 4, -5, -1, 0, -2, -1, -5, -5, -1, -5, -5, -4, -1, -2, -6, -4, -5, 4, 1, -2, -7},
   {-2, -1, -1, 0, -6, 4, 5, -4, -1, -5, -4, 0, -3, -5, -3, -1, -2, -4, -4, -4, 1, 4, -2, -7},
   {-1, -2, -2, -3, -4, -2, -2, -3, -3, -2, -2, -2, -2, -3, -3, -1, -1, -4, -3, -2, -2, -2, -2, -7},
   {-7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, 1}};


blosum_matrix_t blosum30 = {
{4, -1, 0, 0, -3, 1, 0, 0, -2, 0, -1, 0, 1, -2, -1, 1, 1, -5, -4, 1, 0, 0, 0, -7},
{-1, 8, -2, -1, -2, 3, -1, -2, -1, -3, -2, 1, 0, -1, -1, -1, -3, 0, 0, -1, -2, 0, -1, -7},
{ 0, -2, 8, 1, -1, -1, -1, 0, -1, 0, -2, 0, 0, -1, -3, 0, 1, -7, -4, -2, 4, -1, 0, -7},
{ 0, -1, 1, 9, -3, -1, 1, -1, -2, -4, -1, 0, -3, -5, -1, 0, -1, -4, -1, -2, 5, 0, -1, -7},
{ -3, -2, -1, -3, 17, -2, 1, -4, -5, -2, 0, -3, -2, -3, -3, -2, -2, -2, -6, -2, -2, 0, -2, -7},
{ 1, 3, -1, -1, -2, 8, 2, -2, 0, -2, -2, 0, -1, -3, 0, -1, 0, -1, -1, -3, -1, 4, 0, -7},
{ 0, -1, -1, 1, 1, 2, 6, -2, 0, -3, -1, 2, -1, -4, 1, 0, -2, -1, -2, -3, 0, 5, -1, -7},
{ 0, -2, 0, -1, -4, -2, -2, 8, -3, -1, -2, -1, -2, -3, -1, 0, -2, 1, -3, -3, 0, -2, -1, -7},
{ -2, -1, -1, -2, -5, 0, 0, -3, 14, -2, -1, -2, 2, -3, 1, -1, -2, -5, 0, -3, -2, 0, -1, -7},
{ 0, -3, 0, -4, -2, -2, -3, -1, -2, 6, 2, -2, 1, 0, -3, -1, 0, -3, -1, 4, -2, -3, 0, -7},
{ -1, -2, -2, -1, 0, -2, -1, -2, -1, 2, 4, -2, 2, 2, -3, -2, 0, -2, 3, 1, -1, -1, 0, -7},
{ 0, 1, 0, 0, -3, 0, 2, -1, -2, -2, -2, 4, 2, -1, 1, 0, -1, -2, -1, -2, 0, 1, 0, -7},
{ 1, 0, 0, -3, -2, -1, -1, -2, 2, 1, 2, 2, 6, -2, -4, -2, 0, -3, -1, 0, -2, -1, 0, -7},
{ -2, -1, -1, -5, -3, -3, -4, -3, -3, 0, 2, -1, -2, 10, -4, -1, -2, 1, 3, 1, -3, -4, -1, -7},
{ -1, -1, -3, -1, -3, 0, 1, -1, 1, -3, -3, 1, -4, -4, 11, -1, 0, -3, -2, -4, -2, 0, -1, -7},
{ 1, -1, 0, 0, -2, -1, 0, 0, -1, -1, -2, 0, -2, -1, -1, 4, 2, -3, -2, -1, 0, -1, 0, -7},
{ 1, -3, 1, -1, -2, 0, -2, -2, -2, 0, 0, -1, 0, -2, 0, 2, 5, -5, -1, 1, 0, -1, 0, -7},
{ -5, 0, -7, -4, -2, -1, -1, 1, -5, -3, -2, -2, -3, 1, -3, -3, -5, 20, 5, -3, -5, -1, -2, -7},
{ -4, 0, -4, -1, -6, -1, -2, -3, 0, -1, 3, -1, -1, 3, -2, -2, -1, 5, 9, 1, -3, -2, -1, -7},
{ 1, -1, -2, -2, -2, -3, -3, -3, -3, 4, 1, -2, 0, 1, -4, -1, 1, -3, 1, 5, -2, -3, 0, -7},
{ 0, -2, 4, 5, -2, -1, 0, 0, -2, -2, -1, 0, -2, -3, -2, 0, 0, -5, -3, -2, 5, 0, -1, -7},
{ 0, 0, -1, 0, 0, 4, 5, -2, 0, -3, -1, 1, -1, -4, 0, -1, -1, -1, -2, -3, 0, 4, 0, -7},
{ 0, -1, 0, -1, -2, 0, -1, -1, -1, 0, 0, 0, 0, -1, -1, 0, 0, -2, -1, 0, -1, 0, -1, -7},
{ -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, 1}};

blosum_matrix_t blosum35 = {
{5, -1, -1, -1, -2, 0, -1, 0, -2, -1, -2, 0, 0, -2, -2, 1, 0, -2, -1, 0, -1, -1, 0, -5},
{-1, 8, -1, -1, -3, 2, -1, -2, -1, -3, -2, 2, 0, -1, -2, -1, -2, 0, 0, -1, -1, 0, -1, -5},
{-1, -1, 7, 1, -1, 1, -1, 1, 1, -1, -2, 0, -1, -1, -2, 0, 0, -2, -2, -2, 4, 0, 0, -5},
{-1, -1, 1, 8, -3, -1, 2, -2, 0, -3, -2, -1, -3, -3, -1, -1, -1, -3, -2, -2, 5, 1, -1, -5},
{-2, -3, -1, -3, 15, -3, -1, -3, -4, -4, -2, -2, -4, -4, -4, -3, -1, -5, -5, -2, -2, -2, -2, -5},
{0, 2, 1, -1, -3, 7, 2, -2, -1, -2, -2, 0, -1, -4, 0, 0, 0, -1, 0, -3, 0, 4, -1, -5},
{-1, -1, -1, 2, -1, 2, 6, -2, -1, -3, -1, 1, -2, -3, 0, 0, -1, -1, -1, -2, 0, 5, -1, -5},
{0, -2, 1, -2, -3, -2, -2, 7, -2, -3, -3, -1, -1, -3, -2, 1, -2, -1, -2, -3, 0, -2, -1, -5},
{-2, -1, 1, 0, -4, -1, -1, -2, 12, -3, -2, -2, 1, -3, -1, -1, -2, -4, 0, -4, 0, -1, -1, -5},
{-1, -3, -1, -3, -4, -2, -3, -3, -3, 5, 2, -2, 1, 1, -1, -2, -1, -1, 0, 4, -2, -3, 0, -5},
{-2, -2, -2, -2, -2, -2, -1, -3, -2, 2, 5, -2, 3, 2, -3, -2, 0, 0, 0, 2, -2, -2, 0, -5},
{0, 2, 0, -1, -2, 0, 1, -1, -2, -2, -2, 5, 0, -1, 0, 0, 0, 0, -1, -2, 0, 1, 0, -5},
{0, 0, -1, -3, -4, -1, -2, -1, 1, 1, 3, 0, 6, 0, -3, -1, 0, 1, 0, 1, -2, -2, 0, -5},
{-2, -1, -1, -3, -4, -4, -3, -3, -3, 1, 2, -1, 0, 8, -4, -1, -1, 1, 3, 1, -2, -3, -1, -5},
{-2, -2, -2, -1, -4, 0, 0, -2, -1, -1, -3, 0, -3, -4, 10, -2, 0, -4, -3, -3, -1, 0, -1, -5},
{1, -1, 0, -1, -3, 0, 0, 1, -1, -2, -2, 0, -1, -1, -2, 4, 2, -2, -1, -1, 0, 0, 0, -5},
{0, -2, 0, -1, -1, 0, -1, -2, -2, -1, 0, 0, 0, -1, 0, 2, 5, -2, -2, 1, -1, -1, 0, -5},
{-2, 0, -2, -3, -5, -1, -1, -1, -4, -1, 0, 0, 1, 1, -4, -2, -2, 16, 3, -2, -3, -1, -1, -5},
{-1, 0, -2, -2, -5, 0, -1, -2, 0, 0, 0, -1, 0, 3, -3, -1, -2, 3, 8, 0, -2, -1, -1, -5},
{0, -1, -2, -2, -2, -3, -2, -3, -4, 4, 2, -2, 1, 1, -3, -1, 1, -2, 0, 5, -2, -2, 0, -5},
{-1, -1, 4, 5, -2, 0, 0, 0, 0, -2, -2, 0, -2, -2, -1, 0, -1, -3, -2, -2, 5, 0, -1, -5},
{-1, 0, 0, 1, -2, 4, 5, -2, -1, -3, -2, 1, -2, -3, 0, 0, -1, -1, -1, -2, 0, 4, 0, -5},
{0, -1, 0, -1, -2, -1, -1, -1, -1, 0, 0, 0, 0, -1, -1, 0, 0, -1, -1, 0, -1, 0, -1, -5},
{-5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, 1}};


blosum_matrix_t blosum40 = {
{5, -2, -1, -1, -2, 0, -1, 1, -2, -1, -2, -1, -1, -3, -2, 1, 0, -3, -2, 0, -1, -1, 0, -6},
{-2, 9, 0, -1, -3, 2, -1, -3, 0, -3, -2, 3, -1, -2, -3, -1, -2, -2, -1, -2, -1, 0, -1, -6},
{-1, 0, 8, 2, -2, 1, -1, 0, 1, -2, -3, 0, -2, -3, -2, 1, 0, -4, -2, -3, 4, 0, -1, -6},
{-1, -1, 2, 9, -2, -1, 2, -2, 0, -4, -3, 0, -3, -4, -2, 0, -1, -5, -3, -3, 6, 1, -1, -6},
{-2, -3, -2, -2, 16, -4, -2, -3, -4, -4, -2, -3, -3, -2, -5, -1, -1, -6, -4, -2, -2, -3, -2, -6},
{0, 2, 1, -1, -4, 8, 2, -2, 0, -3, -2, 1, -1, -4, -2, 1, -1, -1, -1, -3, 0, 4, -1, -6},
{-1, -1, -1, 2, -2, 2, 7, -3, 0, -4, -2, 1, -2, -3, 0, 0, -1, -2, -2, -3, 1, 5, -1, -6},
{1, -3, 0, -2, -3, -2, -3, 8, -2, -4, -4, -2, -2, -3, -1, 0, -2, -2, -3, -4, -1, -2, -1, -6},
{-2, 0, 1, 0, -4, 0, 0, -2, 13, -3, -2, -1, 1, -2, -2, -1, -2, -5, 2, -4, 0, 0, -1, -6},
{-1, -3, -2, -4, -4, -3, -4, -4, -3, 6, 2, -3, 1, 1, -2, -2, -1, -3, 0, 4, -3, -4, -1, -6},
{-2, -2, -3, -3, -2, -2, -2, -4, -2, 2, 6, -2, 3, 2, -4, -3, -1, -1, 0, 2, -3, -2, -1, -6},
{-1, 3, 0, 0, -3, 1, 1, -2, -1, -3, -2, 6, -1, -3, -1, 0, 0, -2, -1, -2, 0, 1, -1, -6},
{-1, -1, -2, -3, -3, -1, -2, -2, 1, 1, 3, -1, 7, 0, -2, -2, -1, -2, 1, 1, -3, -2, 0, -6},
{-3, -2, -3, -4, -2, -4, -3, -3, -2, 1, 2, -3, 0, 9, -4, -2, -1, 1, 4, 0, -3, -4, -1, -6},
{-2, -3, -2, -2, -5, -2, 0, -1, -2, -2, -4, -1, -2, -4, 11, -1, 0, -4, -3, -3, -2, -1, -2, -6},
{1, -1, 1, 0, -1, 1, 0, 0, -1, -2, -3, 0, -2, -2, -1, 5, 2, -5, -2, -1, 0, 0, 0, -6},
{0, -2, 0, -1, -1, -1, -1, -2, -2, -1, -1, 0, -1, -1, 0, 2, 6, -4, -1, 1, 0, -1, 0, -6},
{-3, -2, -4, -5, -6, -1, -2, -2, -5, -3, -1, -2, -2, 1, -4, -5, -4, 19, 3, -3, -4, -2, -2, -6},
{-2, -1, -2, -3, -4, -1, -2, -3, 2, 0, 0, -1, 1, 4, -3, -2, -1, 3, 9, -1, -3, -2, -1, -6},
{0, -2, -3, -3, -2, -3, -3, -4, -4, 4, 2, -2, 1, 0, -3, -1, 1, -3, -1, 5, -3, -3, -1, -6},
{-1, -1, 4, 6, -2, 0, 1, -1, 0, -3, -3, 0, -3, -3, -2, 0, 0, -4, -3, -3, 5, 2, -1, -6},
{-1, 0, 0, 1, -3, 4, 5, -2, 0, -4, -2, 1, -2, -4, -1, 0, -1, -2, -2, -3, 2, 5, -1, -6},
{0, -1, -1, -1, -2, -1, -1, -1, -1, -1, -1, -1, 0, -1, -2, 0, 0, -2, -1, -1, -1, -1, -1, -6},
{-6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, 1}};


blosum_matrix_t blosum45 = {
{5, -2, -1, -2, -1, -1, -1, 0, -2, -1, -1, -1, -1, -2, -1, 1, 0, -2, -2, 0, -1, -1, 0, -5},
{-2, 7, 0, -1, -3, 1, 0, -2, 0, -3, -2, 3, -1, -2, -2, -1, -1, -2, -1, -2, -1, 0, -1, -5},
{-1, 0, 6, 2, -2, 0, 0, 0, 1, -2, -3, 0, -2, -2, -2, 1, 0, -4, -2, -3, 4, 0, -1, -5},
{-2, -1, 2, 7, -3, 0, 2, -1, 0, -4, -3, 0, -3, -4, -1, 0, -1, -4, -2, -3, 5, 1, -1, -5},
{-1, -3, -2, -3, 12, -3, -3, -3, -3, -3, -2, -3, -2, -2, -4, -1, -1, -5, -3, -1, -2, -3, -2, -5},
{-1, 1, 0, 0, -3, 6, 2, -2, 1, -2, -2, 1, 0, -4, -1, 0, -1, -2, -1, -3, 0, 4, -1, -5},
{-1, 0, 0, 2, -3, 2, 6, -2, 0, -3, -2, 1, -2, -3, 0, 0, -1, -3, -2, -3, 1, 4, -1, -5},
{0, -2, 0, -1, -3, -2, -2, 7, -2, -4, -3, -2, -2, -3, -2, 0, -2, -2, -3, -3, -1, -2, -1, -5},
{-2, 0, 1, 0, -3, 1, 0, -2, 10, -3, -2, -1, 0, -2, -2, -1, -2, -3, 2, -3, 0, 0, -1, -5},
{-1, -3, -2, -4, -3, -2, -3, -4, -3, 5, 2, -3, 2, 0, -2, -2, -1, -2, 0, 3, -3, -3, -1, -5},
{-1, -2, -3, -3, -2, -2, -2, -3, -2, 2, 5, -3, 2, 1, -3, -3, -1, -2, 0, 1, -3, -2, -1, -5},
{-1, 3, 0, 0, -3, 1, 1, -2, -1, -3, -3, 5, -1, -3, -1, -1, -1, -2, -1, -2, 0, 1, -1, -5},
{-1, -1, -2, -3, -2, 0, -2, -2, 0, 2, 2, -1, 6, 0, -2, -2, -1, -2, 0, 1, -2, -1, -1, -5},
{-2, -2, -2, -4, -2, -4, -3, -3, -2, 0, 1, -3, 0, 8, -3, -2, -1, 1, 3, 0, -3, -3, -1, -5},
{-1, -2, -2, -1, -4, -1, 0, -2, -2, -2, -3, -1, -2, -3, 9, -1, -1, -3, -3, -3, -2, -1, -1, -5},
{1, -1, 1, 0, -1, 0, 0, 0, -1, -2, -3, -1, -2, -2, -1, 4, 2, -4, -2, -1, 0, 0, 0, -5},
{0, -1, 0, -1, -1, -1, -1, -2, -2, -1, -1, -1, -1, -1, -1, 2, 5, -3, -1, 0, 0, -1, 0, -5},
{-2, -2, -4, -4, -5, -2, -3, -2, -3, -2, -2, -2, -2, 1, -3, -4, -3, 15, 3, -3, -4, -2, -2, -5},
{-2, -1, -2, -2, -3, -1, -2, -3, 2, 0, 0, -1, 0, 3, -3, -2, -1, 3, 8, -1, -2, -2, -1, -5},
{0, -2, -3, -3, -1, -3, -3, -3, -3, 3, 1, -2, 1, 0, -3, -1, 0, -3, -1, 5, -3, -3, -1, -5},
{-1, -1, 4, 5, -2, 0, 1, -1, 0, -3, -3, 0, -2, -3, -2, 0, 0, -4, -2, -3, 4, 2, -1, -5},
{-1, 0, 0, 1, -3, 4, 4, -2, 0, -3, -2, 1, -1, -3, -1, 0, -1, -2, -2, -3, 2, 4, -1, -5},
{0, -1, -1, -1, -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 0, -2, -1, -1, -1, -1, -1, -5},
{-5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, 1}};

blosum_matrix_t blosum50 = {
{5, -2, -1, -2, -1, -1, -1, 0, -2, -1, -2, -1, -1, -3, -1, 1, 0, -3, -2, 0, -2, -1, -1, -5},
{-2, 7, -1, -2, -4, 1, 0, -3, 0, -4, -3, 3, -2, -3, -3, -1, -1, -3, -1, -3, -1, 0, -1, -5},
{-1, -1, 7, 2, -2, 0, 0, 0, 1, -3, -4, 0, -2, -4, -2, 1, 0, -4, -2, -3, 4, 0, -1, -5},
{-2, -2, 2, 8, -4, 0, 2, -1, -1, -4, -4, -1, -4, -5, -1, 0, -1, -5, -3, -4, 5, 1, -1, -5},
{-1, -4, -2, -4, 13, -3, -3, -3, -3, -2, -2, -3, -2, -2, -4, -1, -1, -5, -3, -1, -3, -3, -2, -5},
{-1, 1, 0, 0, -3, 7, 2, -2, 1, -3, -2, 2, 0, -4, -1, 0, -1, -1, -1, -3, 0, 4, -1, -5},
{-1, 0, 0, 2, -3, 2, 6, -3, 0, -4, -3, 1, -2, -3, -1, -1, -1, -3, -2, -3, 1, 5, -1, -5},
{0, -3, 0, -1, -3, -2, -3, 8, -2, -4, -4, -2, -3, -4, -2, 0, -2, -3, -3, -4, -1, -2, -2, -5},
{-2, 0, 1, -1, -3, 1, 0, -2, 10, -4, -3, 0, -1, -1, -2, -1, -2, -3, 2, -4, 0, 0, -1, -5},
{-1, -4, -3, -4, -2, -3, -4, -4, -4, 5, 2, -3, 2, 0, -3, -3, -1, -3, -1, 4, -4, -3, -1, -5},
{-2, -3, -4, -4, -2, -2, -3, -4, -3, 2, 5, -3, 3, 1, -4, -3, -1, -2, -1, 1, -4, -3, -1, -5},
{-1, 3, 0, -1, -3, 2, 1, -2, 0, -3, -3, 6, -2, -4, -1, 0, -1, -3, -2, -3, 0, 1, -1, -5},
{-1, -2, -2, -4, -2, 0, -2, -3, -1, 2, 3, -2, 7, 0, -3, -2, -1, -1, 0, 1, -3, -1, -1, -5},
{-3, -3, -4, -5, -2, -4, -3, -4, -1, 0, 1, -4, 0, 8, -4, -3, -2, 1, 4, -1, -4, -4, -2, -5},
{-1, -3, -2, -1, -4, -1, -1, -2, -2, -3, -4, -1, -3, -4, 10, -1, -1, -4, -3, -3, -2, -1, -2, -5},
{1, -1, 1, 0, -1, 0, -1, 0, -1, -3, -3, 0, -2, -3, -1, 5, 2, -4, -2, -2, 0, 0, -1, -5},
{0, -1, 0, -1, -1, -1, -1, -2, -2, -1, -1, -1, -1, -2, -1, 2, 5, -3, -2, 0, 0, -1, 0, -5},
{-3, -3, -4, -5, -5, -1, -3, -3, -3, -3, -2, -3, -1, 1, -4, -4, -3, 15, 2, -3, -5, -2, -3, -5},
{-2, -1, -2, -3, -3, -1, -2, -3, 2, -1, -1, -2, 0, 4, -3, -2, -2, 2, 8, -1, -3, -2, -1, -5},
{0, -3, -3, -4, -1, -3, -3, -4, -4, 4, 1, -3, 1, -1, -3, -2, 0, -3, -1, 5, -4, -3, -1, -5},
{-2, -1, 4, 5, -3, 0, 1, -1, 0, -4, -4, 0, -3, -4, -2, 0, 0, -5, -3, -4, 5, 2, -1, -5},
{-1, 0, 0, 1, -3, 4, 5, -2, 0, -3, -3, 1, -1, -4, -1, 0, -1, -2, -2, -3, 2, 5, -1, -5},
{-1, -1, -1, -1, -2, -1, -1, -2, -1, -1, -1, -1, -1, -2, -2, -1, 0, -3, -1, -1, -1, -1, -1, -5},
{-5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, 1}};

blosum_matrix_t blosum55 = {
{5, -2, -2, -2, 0, -1, -1, 0, -2, -2, -2, -1, -1, -3, -1, 2, 0, -4, -2, 0, -2, -1, -1, -5},
{-2, 8, -1, -2, -4, 1, 0, -3, 0, -4, -3, 3, -2, -3, -3, -1, -1, -3, -2, -3, -1, 0, -1, -5},
{-2, -1, 8, 2, -3, 0, 0, 0, 1, -4, -4, 0, -3, -4, -2, 1, 0, -5, -2, -4, 4, 0, -1, -5},
{-2, -2, 2, 8, -4, 0, 2, -2, -1, -4, -5, -1, -4, -5, -2, 0, -1, -5, -3, -4, 5, 1, -2, -5},
{0, -4, -3, -4, 13, -4, -4, -3, -4, -2, -2, -4, -2, -3, -3, -1, -1, -4, -3, -1, -4, -4, -2, -5},
{-1, 1, 0, 0, -4, 7, 2, -2, 1, -4, -3, 2, 0, -4, -1, 0, -1, -2, -1, -3, 0, 4, -1, -5},
{-1, 0, 0, 2, -4, 2, 7, -3, -1, -4, -4, 1, -3, -4, -1, 0, -1, -3, -2, -3, 1, 5, -1, -5},
{0, -3, 0, -2, -3, -2, -3, 8, -2, -5, -5, -2, -3, -4, -3, 0, -2, -3, -4, -4, -1, -3, -2, -5},
{-2, 0, 1, -1, -4, 1, -1, -2, 11, -4, -3, 0, -2, -1, -3, -1, -2, -3, 2, -4, 0, 0, -1, -5},
{-2, -4, -4, -4, -2, -4, -4, -5, -4, 6, 2, -4, 2, 0, -3, -3, -1, -3, -1, 4, -4, -4, -1, -5},
{-2, -3, -4, -5, -2, -3, -4, -5, -3, 2, 6, -3, 3, 1, -4, -3, -2, -3, -1, 1, -4, -3, -1, -5},
{-1, 3, 0, -1, -4, 2, 1, -2, 0, -4, -3, 6, -2, -4, -1, 0, -1, -4, -2, -3, 0, 1, -1, -5},
{-1, -2, -3, -4, -2, 0, -3, -3, -2, 2, 3, -2, 8, 0, -3, -2, -1, -2, -1, 1, -3, -2, -1, -5},
{-3, -3, -4, -5, -3, -4, -4, -4, -1, 0, 1, -4, 0, 9, -5, -3, -3, 2, 4, -1, -5, -4, -2, -5},
{-1, -3, -2, -2, -3, -1, -1, -3, -3, -3, -4, -1, -3, -5, 10, -1, -1, -5, -4, -3, -2, -1, -2, -5},
{2, -1, 1, 0, -1, 0, 0, 0, -1, -3, -3, 0, -2, -3, -1, 5, 2, -4, -2, -2, 0, 0, -1, -5},
{0, -1, 0, -1, -1, -1, -1, -2, -2, -1, -2, -1, -1, -3, -1, 2, 6, -3, -2, 0, -1, -1, -1, -5},
{-4, -3, -5, -5, -4, -2, -3, -3, -3, -3, -3, -4, -2, 2, -5, -4, -3, 15, 3, -4, -5, -3, -3, -5},
{-2, -2, -2, -3, -3, -1, -2, -4, 2, -1, -1, -2, -1, 4, -4, -2, -2, 3, 9, -2, -3, -2, -1, -5},
{0, -3, -4, -4, -1, -3, -3, -4, -4, 4, 1, -3, 1, -1, -3, -2, 0, -4, -2, 5, -4, -3, -1, -5},
{-2, -1, 4, 5, -4, 0, 1, -1, 0, -4, -4, 0, -3, -5, -2, 0, -1, -5, -3, -4, 5, 2, -1, -5},
{-1, 0, 0, 1, -4, 4, 5, -3, 0, -4, -3, 1, -2, -4, -1, 0, -1, -3, -2, -3, 2, 5, -1, -5},
{-1, -1, -1, -2, -2, -1, -1, -2, -1, -1, -1, -1, -1, -2, -2, -1, -1, -3, -1, -1, -1, -1, -1, -5},
{-5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, 1}};


blosum_matrix_t blosum60 = {
{4, -1, -1, -2, 0, -1, -1, 0, -2, -1, -1, -1, -1, -2, -1, 1, 0, -3, -2, 0, -2, -1, 0, -4},
{-1, 5, 0, -1, -3, 1, 0, -2, 0, -3, -2, 2, -1, -3, -2, -1, -1, -3, -2, -2, -1, 0, -1, -4},
{-1, 0, 6, 1, -2, 0, 0, 0, 1, -3, -3, 0, -2, -3, -2, 1, 0, -4, -2, -3, 3, 0, -1, -4},
{-2, -1, 1, 6, -3, 0, 2, -1, -1, -3, -3, -1, -3, -3, -1, 0, -1, -4, -3, -3, 4, 1, -1, -4},
{0, -3, -2, -3, 9, -3, -3, -2, -3, -1, -1, -3, -1, -2, -3, -1, -1, -2, -2, -1, -3, -3, -2, -4},
{-1, 1, 0, 0, -3, 5, 2, -2, 1, -3, -2, 1, 0, -3, -1, 0, -1, -2, -1, -2, 0, 3, -1, -4},
{-1, 0, 0, 2, -3, 2, 5, -2, 0, -3, -3, 1, -2, -3, -1, 0, -1, -3, -2, -2, 1, 4, -1, -4},
{0, -2, 0, -1, -2, -2, -2, 6, -2, -3, -4, -1, -2, -3, -2, 0, -2, -2, -3, -3, -1, -2, -1, -4},
{-2, 0, 1, -1, -3, 1, 0, -2, 7, -3, -3, -1, -1, -1, -2, -1, -2, -2, 2, -3, 0, 0, -1, -4},
{-1, -3, -3, -3, -1, -3, -3, -3, -3, 4, 2, -3, 1, 0, -3, -2, -1, -2, -1, 3, -3, -3, -1, -4},
{-1, -2, -3, -3, -1, -2, -3, -4, -3, 2, 4, -2, 2, 0, -3, -2, -1, -2, -1, 1, -3, -2, -1, -4},
{-1, 2, 0, -1, -3, 1, 1, -1, -1, -3, -2, 4, -1, -3, -1, 0, -1, -3, -2, -2, 0, 1, -1, -4},
{-1, -1, -2, -3, -1, 0, -2, -2, -1, 1, 2, -1, 5, 0, -2, -1, -1, -1, -1, 1, -3, -1, -1, -4},
{-2, -3, -3, -3, -2, -3, -3, -3, -1, 0, 0, -3, 0, 6, -4, -2, -2, 1, 3, -1, -3, -3, -1, -4},
{-1, -2, -2, -1, -3, -1, -1, -2, -2, -3, -3, -1, -2, -4, 7, -1, -1, -4, -3, -2, -2, -1, -2, -4},
{1, -1, 1, 0, -1, 0, 0, 0, -1, -2, -2, 0, -1, -2, -1, 4, 1, -3, -2, -2, 0, 0, 0, -4},
{0, -1, 0, -1, -1, -1, -1, -2, -2, -1, -1, -1, -1, -2, -1, 1, 4, -2, -2, 0, 0, -1, 0, -4},
{-3, -3, -4, -4, -2, -2, -3, -2, -2, -2, -2, -3, -1, 1, -4, -3, -2, 10, 2, -3, -4, -2, -2, -4},
{-2, -2, -2, -3, -2, -1, -2, -3, 2, -1, -1, -2, -1, 3, -3, -2, -2, 2, 6, -1, -2, -2, -1, -4},
{0, -2, -3, -3, -1, -2, -2, -3, -3, 3, 1, -2, 1, -1, -2, -2, 0, -3, -1, 4, -3, -2, -1, -4},
{-2, -1, 3, 4, -3, 0, 1, -1, 0, -3, -3, 0, -3, -3, -2, 0, 0, -4, -2, -3, 4, 1, -1, -4},
{-1, 0, 0, 1, -3, 3, 4, -2, 0, -3, -2, 1, -1, -3, -1, 0, -1, -2, -2, -2, 1, 3, -1, -4},
{0, -1, -1, -1, -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -2, 0, 0, -2, -1, -1, -1, -1, -1, -4},
{-4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, 1}};

blosum_matrix_t blosum62 = {
   {4, -1, -2, -2, 0, -1, -1, 0, -2, -1, -1, -1, -1, -2, -1, 1, 0, -3, -2, 0, -2, -1, 0, -4},
   {-1, 5, 0, -2, -3, 1, 0, -2, 0, -3, -2, 2, -1, -3, -2, -1, -1, -3, -2, -3, -1, 0, -1, -4},
   {-2, 0, 6, 1, -3, 0, 0, 0, 1, -3, -3, 0, -2, -3, -2, 1, 0, -4, -2, -3, 3, 0, -1, -4},
   {-2, -2, 1, 6, -3, 0, 2, -1, -1, -3, -4, -1, -3, -3, -1, 0, -1, -4, -3, -3, 4, 1, -1, -4},
   {0, -3, -3, -3, 9, -3, -4, -3, -3, -1, -1, -3, -1, -2, -3, -1, -1, -2, -2, -1, -3, -3, -2, -4},
   {-1, 1, 0, 0, -3, 5, 2, -2, 0, -3, -2, 1, 0, -3, -1, 0, -1, -2, -1, -2, 0, 3, -1, -4},
   {-1, 0, 0, 2, -4, 2, 5, -2, 0, -3, -3, 1, -2, -3, -1, 0, -1, -3, -2, -2, 1, 4, -1, -4},
   {0, -2, 0, -1, -3, -2, -2, 6, -2, -4, -4, -2, -3, -3, -2, 0, -2, -2, -3, -3, -1, -2, -1, -4},
   {-2, 0, 1, -1, -3, 0, 0, -2, 8, -3, -3, -1, -2, -1, -2, -1, -2, -2, 2, -3, 0, 0, -1, -4},
   {-1, -3, -3, -3, -1, -3, -3, -4, -3, 4, 2, -3, 1, 0, -3, -2, -1, -3, -1, 3, -3, -3, -1, -4},
   {-1, -2, -3, -4, -1, -2, -3, -4, -3, 2, 4, -2, 2, 0, -3, -2, -1, -2, -1, 1, -4, -3, -1, -4},
   {-1, 2, 0, -1, -3, 1, 1, -2, -1, -3, -2, 5, -1, -3, -1, 0, -1, -3, -2, -2, 0, 1, -1, -4},
   {-1, -1, -2, -3, -1, 0, -2, -3, -2, 1, 2, -1, 5, 0, -2, -1, -1, -1, -1, 1, -3, -1, -1, -4},
   {-2, -3, -3, -3, -2, -3, -3, -3, -1, 0, 0, -3, 0, 6, -4, -2, -2, 1, 3, -1, -3, -3, -1, -4},
   {-1, -2, -2, -1, -3, -1, -1, -2, -2, -3, -3, -1, -2, -4, 7, -1, -1, -4, -3, -2, -2, -1, -2, -4},
   {1, -1, 1, 0, -1, 0, 0, 0, -1, -2, -2, 0, -1, -2, -1, 4, 1, -3, -2, -2, 0, 0, 0, -4},
   {0, -1, 0, -1, -1, -1, -1, -2, -2, -1, -1, -1, -1, -2, -1, 1, 5, -2, -2, 0, -1, -1, 0, -4},
   {-3, -3, -4, -4, -2, -2, -3, -2, -2, -3, -2, -3, -1, 1, -4, -3, -2, 11, 2, -3, -4, -3, -2, -4},
   {-2, -2, -2, -3, -2, -1, -2, -3, 2, -1, -1, -2, -1, 3, -3, -2, -2, 2, 7, -1, -3, -2, -1, -4},
   {0, -3, -3, -3, -1, -2, -2, -3, -3, 3, 1, -2, 1, -1, -2, -2, 0, -3, -1, 4, -3, -2, -1, -4},
   {-2, -1, 3, 4, -3, 0, 1, -1, 0, -3, -4, 0, -3, -3, -2, 0, -1, -4, -3, -3, 4, 1, -1, -4},
   {-1, 0, 0, 1, -3, 3, 4, -2, 0, -3, -3, 1, -1, -3, -1, 0, -1, -3, -2, -2, 1, 4, -1, -4},
   {0, -1, -1, -1, -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -2, 0, 0, -2, -1, -1, -1, -1, -1, -4},
   {-4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, 1}};


blosum_matrix_t blosum65 = {
{4, -1, -2, -2, 0, -1, -1, 0, -2, -1, -2, -1, -1, -2, -1, 1, 0, -3, -2, 0, -2, -1, -1, -5},
{-1, 6, 0, -2, -4, 1, 0, -2, 0, -3, -2, 2, -2, -3, -2, -1, -1, -3, -2, -3, -1, 0, -1, -5},
{-2, 0, 6, 1, -3, 0, 0, -1, 1, -3, -4, 0, -2, -3, -2, 1, 0, -4, -2, -3, 3, 0, -1, -5},
{-2, -2, 1, 6, -4, 0, 2, -1, -1, -3, -4, -1, -3, -4, -2, 0, -1, -5, -3, -3, 4, 1, -1, -5},
{0, -4, -3, -4, 9, -3, -4, -3, -3, -1, -1, -3, -2, -2, -3, -1, -1, -2, -2, -1, -3, -4, -2, -5},
{-1, 1, 0, 0, -3, 6, 2, -2, 1, -3, -2, 1, 0, -3, -1, 0, -1, -2, -2, -2, 0, 3, -1, -5},
{-1, 0, 0, 2, -4, 2, 5, -2, 0, -3, -3, 1, -2, -3, -1, 0, -1, -3, -2, -3, 1, 4, -1, -5},
{0, -2, -1, -1, -3, -2, -2, 6, -2, -4, -4, -2, -3, -3, -2, 0, -2, -3, -3, -3, -1, -2, -2, -5},
{-2, 0, 1, -1, -3, 1, 0, -2, 8, -3, -3, -1, -2, -1, -2, -1, -2, -2, 2, -3, 0, 0, -1, -5},
{-1, -3, -3, -3, -1, -3, -3, -4, -3, 4, 2, -3, 1, 0, -3, -2, -1, -2, -1, 3, -3, -3, -1, -5},
{-2, -2, -4, -4, -1, -2, -3, -4, -3, 2, 4, -3, 2, 0, -3, -3, -1, -2, -1, 1, -4, -3, -1, -5},
{-1, 2, 0, -1, -3, 1, 1, -2, -1, -3, -3, 5, -2, -3, -1, 0, -1, -3, -2, -2, 0, 1, -1, -5},
{-1, -2, -2, -3, -2, 0, -2, -3, -2, 1, 2, -2, 6, 0, -3, -2, -1, -2, -1, 1, -3, -2, -1, -5},
{-2, -3, -3, -4, -2, -3, -3, -3, -1, 0, 0, -3, 0, 6, -4, -2, -2, 1, 3, -1, -3, -3, -2, -5},
{-1, -2, -2, -2, -3, -1, -1, -2, -2, -3, -3, -1, -3, -4, 8, -1, -1, -4, -3, -2, -2, -1, -2, -5},
{1, -1, 1, 0, -1, 0, 0, 0, -1, -2, -3, 0, -2, -2, -1, 4, 1, -3, -2, -2, 0, 0, -1, -5},
{0, -1, 0, -1, -1, -1, -1, -2, -2, -1, -1, -1, -1, -2, -1, 1, 5, -3, -2, 0, -1, -1, -1, -5},
{-3, -3, -4, -5, -2, -2, -3, -3, -2, -2, -2, -3, -2, 1, -4, -3, -3, 10, 2, -3, -4, -3, -2, -5},
{-2, -2, -2, -3, -2, -2, -2, -3, 2, -1, -1, -2, -1, 3, -3, -2, -2, 2, 7, -1, -3, -2, -1, -5},
{0, -3, -3, -3, -1, -2, -3, -3, -3, 3, 1, -2, 1, -1, -2, -2, 0, -3, -1, 4, -3, -2, -1, -5},
{-2, -1, 3, 4, -3, 0, 1, -1, 0, -3, -4, 0, -3, -3, -2, 0, -1, -4, -3, -3, 4, 1, -1, -5},
{-1, 0, 0, 1, -4, 3, 4, -2, 0, -3, -3, 1, -2, -3, -1, 0, -1, -3, -2, -2, 1, 4, -1, -5},
{-1, -1, -1, -1, -2, -1, -1, -2, -1, -1, -1, -1, -1, -2, -2, -1, -1, -2, -1, -1, -1, -1, -1, -5},
{-5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, 1}};


blosum_matrix_t blosum70 = {
{4, -2, -2, -2, -1, -1, -1, 0, -2, -2, -2, -1, -1, -2, -1, 1, 0, -3, -2, 0, -2, -1, -1, -5},
{-2, 6, -1, -2, -4, 1, 0, -3, 0, -3, -3, 2, -2, -3, -2, -1, -1, -3, -2, -3, -1, 0, -1, -5},
{-2, -1, 6, 1, -3, 0, 0, -1, 0, -4, -4, 0, -2, -3, -2, 0, 0, -4, -2, -3, 3, 0, -1, -5},
{-2, -2, 1, 6, -4, -1, 1, -2, -1, -4, -4, -1, -3, -4, -2, 0, -1, -5, -4, -4, 4, 1, -2, -5},
{-1, -4, -3, -4, 9, -3, -4, -3, -4, -1, -2, -4, -2, -2, -3, -1, -1, -3, -3, -1, -4, -4, -2, -5},
{-1, 1, 0, -1, -3, 6, 2, -2, 1, -3, -2, 1, 0, -3, -2, 0, -1, -2, -2, -2, 0, 3, -1, -5},
{-1, 0, 0, 1, -4, 2, 5, -2, 0, -4, -3, 1, -2, -4, -1, 0, -1, -4, -3, -3, 1, 4, -1, -5},
{0, -3, -1, -2, -3, -2, -2, 6, -2, -4, -4, -2, -3, -4, -3, -1, -2, -3, -4, -4, -1, -2, -2, -5},
{-2, 0, 0, -1, -4, 1, 0, -2, 8, -4, -3, -1, -2, -1, -2, -1, -2, -2, 2, -3, -1, 0, -1, -5},
{-2, -3, -4, -4, -1, -3, -4, -4, -4, 4, 2, -3, 1, 0, -3, -3, -1, -3, -1, 3, -4, -3, -1, -5},
{-2, -3, -4, -4, -2, -2, -3, -4, -3, 2, 4, -3, 2, 0, -3, -3, -2, -2, -1, 1, -4, -3, -1, -5},
{-1, 2, 0, -1, -4, 1, 1, -2, -1, -3, -3, 5, -2, -3, -1, 0, -1, -3, -2, -3, -1, 1, -1, -5},
{-1, -2, -2, -3, -2, 0, -2, -3, -2, 1, 2, -2, 6, 0, -3, -2, -1, -2, -1, 1, -3, -2, -1, -5},
{-2, -3, -3, -4, -2, -3, -4, -4, -1, 0, 0, -3, 0, 6, -4, -3, -2, 1, 3, -1, -4, -4, -2, -5},
{-1, -2, -2, -2, -3, -2, -1, -3, -2, -3, -3, -1, -3, -4, 8, -1, -1, -4, -3, -3, -2, -1, -2, -5},
{1, -1, 0, 0, -1, 0, 0, -1, -1, -3, -3, 0, -2, -3, -1, 4, 1, -3, -2, -2, 0, 0, -1, -5},
{0, -1, 0, -1, -1, -1, -1, -2, -2, -1, -2, -1, -1, -2, -1, 1, 5, -3, -2, 0, -1, -1, -1, -5},
{-3, -3, -4, -5, -3, -2, -4, -3, -2, -3, -2, -3, -2, 1, -4, -3, -3, 11, 2, -3, -4, -3, -3, -5},
{-2, -2, -2, -4, -3, -2, -3, -4, 2, -1, -1, -2, -1, 3, -3, -2, -2, 2, 7, -2, -3, -2, -2, -5},
{0, -3, -3, -4, -1, -2, -3, -4, -3, 3, 1, -3, 1, -1, -3, -2, 0, -3, -2, 4, -3, -3, -1, -5},
{-2, -1, 3, 4, -4, 0, 1, -1, -1, -4, -4, -1, -3, -4, -2, 0, -1, -4, -3, -3, 4, 0, -1, -5},
{-1, 0, 0, 1, -4, 3, 4, -2, 0, -3, -3, 1, -2, -4, -1, 0, -1, -3, -2, -3, 0, 4, -1, -5},
{-1, -1, -1, -2, -2, -1, -1, -2, -1, -1, -1, -1, -1, -2, -2, -1, -1, -3, -2, -1, -1, -1, -1, -5},
{-5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, 1}};

blosum_matrix_t blosum75 = {
{4, -2, -2, -2, -1, -1, -1, 0, -2, -2, -2, -1, -1, -3, -1, 1, 0, -3, -2, 0, -2, -1, -1, -5},
{-2, 6, -1, -2, -4, 1, 0, -3, 0, -3, -3, 2, -2, -3, -2, -1, -1, -3, -2, -3, -1, 0, -1, -5},
{-2, -1, 6, 1, -3, 0, -1, -1, 0, -4, -4, 0, -3, -4, -3, 0, 0, -4, -3, -3, 3, 0, -1, -5},
{-2, -2, 1, 6, -4, -1, 1, -2, -1, -4, -4, -1, -4, -4, -2, -1, -1, -5, -4, -4, 4, 1, -2, -5},
{-1, -4, -3, -4, 9, -3, -5, -3, -4, -1, -2, -4, -2, -2, -4, -1, -1, -3, -3, -1, -4, -4, -2, -5},
{-1, 1, 0, -1, -3, 6, 2, -2, 1, -3, -3, 1, 0, -4, -2, 0, -1, -2, -2, -2, 0, 3, -1, -5},
{-1, 0, -1, 1, -5, 2, 5, -3, 0, -4, -4, 1, -2, -4, -1, 0, -1, -4, -3, -3, 1, 4, -1, -5},
{0, -3, -1, -2, -3, -2, -3, 6, -2, -5, -4, -2, -3, -4, -3, -1, -2, -3, -4, -4, -1, -2, -2, -5},
{-2, 0, 0, -1, -4, 1, 0, -2, 8, -4, -3, -1, -2, -2, -2, -1, -2, -2, 2, -4, -1, 0, -1, -5},
{-2, -3, -4, -4, -1, -3, -4, -5, -4, 4, 1, -3, 1, 0, -3, -3, -1, -3, -2, 3, -4, -4, -2, -5},
{-2, -3, -4, -4, -2, -3, -4, -4, -3, 1, 4, -3, 2, 0, -3, -3, -2, -2, -1, 1, -4, -3, -1, -5},
{-1, 2, 0, -1, -4, 1, 1, -2, -1, -3, -3, 5, -2, -4, -1, 0, -1, -4, -2, -3, -1, 1, -1, -5},
{-1, -2, -3, -4, -2, 0, -2, -3, -2, 1, 2, -2, 6, 0, -3, -2, -1, -2, -2, 1, -3, -2, -1, -5},
{-3, -3, -4, -4, -2, -4, -4, -4, -2, 0, 0, -4, 0, 6, -4, -3, -2, 1, 3, -1, -4, -4, -2, -5},
{-1, -2, -3, -2, -4, -2, -1, -3, -2, -3, -3, -1, -3, -4, 8, -1, -1, -5, -4, -3, -2, -2, -2, -5},
{1, -1, 0, -1, -1, 0, 0, -1, -1, -3, -3, 0, -2, -3, -1, 5, 1, -3, -2, -2, 0, 0, -1, -5},
{0, -1, 0, -1, -1, -1, -1, -2, -2, -1, -2, -1, -1, -2, -1, 1, 5, -3, -2, 0, -1, -1, -1, -5},
{-3, -3, -4, -5, -3, -2, -4, -3, -2, -3, -2, -4, -2, 1, -5, -3, -3, 11, 2, -3, -5, -3, -3, -5},
{-2, -2, -3, -4, -3, -2, -3, -4, 2, -2, -1, -2, -2, 3, -4, -2, -2, 2, 7, -2, -3, -3, -2, -5},
{0, -3, -3, -4, -1, -2, -3, -4, -4, 3, 1, -3, 1, -1, -3, -2, 0, -3, -2, 4, -4, -3, -1, -5},
{-2, -1, 3, 4, -4, 0, 1, -1, -1, -4, -4, -1, -3, -4, -2, 0, -1, -5, -3, -4, 4, 0, -2, -5},
{-1, 0, 0, 1, -4, 3, 4, -2, 0, -4, -3, 1, -2, -4, -2, 0, -1, -3, -3, -3, 0, 4, -1, -5},
{-1, -1, -1, -2, -2, -1, -1, -2, -1, -2, -1, -1, -1, -2, -2, -1, -1, -3, -2, -1, -2, -1, -1, -5},
{-5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, 1}};

blosum_matrix_t blosum80 = {
{7, -3, -3, -3, -1, -2, -2, 0, -3, -3, -3, -1, -2, -4, -1, 2, 0, -5, -4, -1, -3, -2, -1, -8},
{-3, 9, -1, -3, -6, 1, -1, -4, 0, -5, -4, 3, -3, -5, -3, -2, -2, -5, -4, -4, -2, 0, -2, -8},
{-3, -1, 9, 2, -5, 0, -1, -1, 1, -6, -6, 0, -4, -6, -4, 1, 0, -7, -4, -5, 5, -1, -2, -8},
{-3, -3, 2, 10, -7, -1, 2, -3, -2, -7, -7, -2, -6, -6, -3, -1, -2, -8, -6, -6, 6, 1, -3, -8},
{-1, -6, -5, -7, 13, -5, -7, -6, -7, -2, -3, -6, -3, -4, -6, -2, -2, -5, -5, -2, -6, -7, -4, -8},
{-2, 1, 0, -1, -5, 9, 3, -4, 1, -5, -4, 2, -1, -5, -3, -1, -1, -4, -3, -4, -1, 5, -2, -8},
{-2, -1, -1, 2, -7, 3, 8, -4, 0, -6, -6, 1, -4, -6, -2, -1, -2, -6, -5, -4, 1, 6, -2, -8},
{0, -4, -1, -3, -6, -4, -4, 9, -4, -7, -7, -3, -5, -6, -5, -1, -3, -6, -6, -6, -2, -4, -3, -8},
{-3, 0, 1, -2, -7, 1, 0, -4, 12, -6, -5, -1, -4, -2, -4, -2, -3, -4, 3, -5, -1, 0, -2, -8},
{-3, -5, -6, -7, -2, -5, -6, -7, -6, 7, 2, -5, 2, -1, -5, -4, -2, -5, -3, 4, -6, -6, -2, -8},
{-3, -4, -6, -7, -3, -4, -6, -7, -5, 2, 6, -4, 3, 0, -5, -4, -3, -4, -2, 1, -7, -5, -2, -8},
{-1, 3, 0, -2, -6, 2, 1, -3, -1, -5, -4, 8, -3, -5, -2, -1, -1, -6, -4, -4, -1, 1, -2, -8},
{-2, -3, -4, -6, -3, -1, -4, -5, -4, 2, 3, -3, 9, 0, -4, -3, -1, -3, -3, 1, -5, -3, -2, -8},
{-4, -5, -6, -6, -4, -5, -6, -6, -2, -1, 0, -5, 0, 10, -6, -4, -4, 0, 4, -2, -6, -6, -3, -8},
{-1, -3, -4, -3, -6, -3, -2, -5, -4, -5, -5, -2, -4, -6, 12, -2, -3, -7, -6, -4, -4, -2, -3, -8},
{2, -2, 1, -1, -2, -1, -1, -1, -2, -4, -4, -1, -3, -4, -2, 7, 2, -6, -3, -3, 0, -1, -1, -8},
{0, -2, 0, -2, -2, -1, -2, -3, -3, -2, -3, -1, -1, -4, -3, 2, 8, -5, -3, 0, -1, -2, -1, -8},
{-5, -5, -7, -8, -5, -4, -6, -6, -4, -5, -4, -6, -3, 0, -7, -6, -5, 16, 3, -5, -8, -5, -5, -8},
{-4, -4, -4, -6, -5, -3, -5, -6, 3, -3, -2, -4, -3, 4, -6, -3, -3, 3, 11, -3, -5, -4, -3, -8},
{-1, -4, -5, -6, -2, -4, -4, -6, -5, 4, 1, -4, 1, -2, -4, -3, 0, -5, -3, 7, -6, -4, -2, -8},
{-3, -2, 5, 6, -6, -1, 1, -2, -1, -6, -7, -1, -5, -6, -4, 0, -1, -8, -5, -6, 6, 0, -3, -8},
{-2, 0, -1, 1, -7, 5, 6, -4, 0, -6, -5, 1, -3, -6, -2, -1, -2, -5, -4, -4, 0, 6, -1, -8},
{-1, -2, -2, -3, -4, -2, -2, -3, -2, -2, -2, -2, -2, -3, -3, -1, -1, -5, -3, -2, -3, -1, -2, -8},
{-8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, 1}};

blosum_matrix_t blosum85 = {
{5, -2, -2, -2, -1, -1, -1, 0, -2, -2, -2, -1, -2, -3, -1, 1, 0, -3, -3, -1, -2, -1, -1, -6},
{-2, 6, -1, -2, -4, 1, -1, -3, 0, -4, -3, 2, -2, -4, -2, -1, -2, -4, -3, -3, -2, 0, -2, -6},
{-2, -1, 7, 1, -4, 0, -1, -1, 0, -4, -4, 0, -3, -4, -3, 0, 0, -5, -3, -4, 4, -1, -2, -6},
{-2, -2, 1, 7, -5, -1, 1, -2, -2, -5, -5, -1, -4, -4, -2, -1, -2, -6, -4, -4, 4, 1, -2, -6},
{-1, -4, -4, -5, 9, -4, -5, -4, -5, -2, -2, -4, -2, -3, -4, -2, -2, -4, -3, -1, -4, -5, -3, -6},
{-1, 1, 0, -1, -4, 6, 2, -3, 1, -4, -3, 1, 0, -4, -2, -1, -1, -3, -2, -3, -1, 4, -1, -6},
{-1, -1, -1, 1, -5, 2, 6, -3, -1, -4, -4, 0, -3, -4, -2, -1, -1, -4, -4, -3, 0, 4, -1, -6},
{0, -3, -1, -2, -4, -3, -3, 6, -3, -5, -5, -2, -4, -4, -3, -1, -2, -4, -5, -4, -1, -3, -2, -6},
{-2, 0, 0, -2, -5, 1, -1, -3, 8, -4, -3, -1, -3, -2, -3, -1, -2, -3, 2, -4, -1, 0, -2, -6},
{-2, -4, -4, -5, -2, -4, -4, -5, -4, 5, 1, -3, 1, -1, -4, -3, -1, -3, -2, 3, -5, -4, -2, -6},
{-2, -3, -4, -5, -2, -3, -4, -5, -3, 1, 4, -3, 2, 0, -4, -3, -2, -3, -2, 0, -5, -4, -2, -6},
{-1, 2, 0, -1, -4, 1, 0, -2, -1, -3, -3, 6, -2, -4, -2, -1, -1, -5, -3, -3, -1, 1, -1, -6},
{-2, -2, -3, -4, -2, 0, -3, -4, -3, 1, 2, -2, 7, -1, -3, -2, -1, -2, -2, 0, -4, -2, -1, -6},
{-3, -4, -4, -4, -3, -4, -4, -4, -2, -1, 0, -4, -1, 7, -4, -3, -3, 0, 3, -1, -4, -4, -2, -6},
{-1, -2, -3, -2, -4, -2, -2, -3, -3, -4, -4, -2, -3, -4, 8, -1, -2, -5, -4, -3, -3, -2, -2, -6},
{1, -1, 0, -1, -2, -1, -1, -1, -1, -3, -3, -1, -2, -3, -1, 5, 1, -4, -2, -2, 0, -1, -1, -6},
{0, -2, 0, -2, -2, -1, -1, -2, -2, -1, -2, -1, -1, -3, -2, 1, 5, -4, -2, 0, -1, -1, -1, -6},
{-3, -4, -5, -6, -4, -3, -4, -4, -3, -3, -3, -5, -2, 0, -5, -4, -4, 11, 2, -3, -5, -4, -3, -6},
{-3, -3, -3, -4, -3, -2, -4, -5, 2, -2, -2, -3, -2, 3, -4, -2, -2, 2, 7, -2, -4, -3, -2, -6},
{-1, -3, -4, -4, -1, -3, -3, -4, -4, 3, 0, -3, 0, -1, -3, -2, 0, -3, -2, 5, -4, -3, -1, -6},
{-2, -2, 4, 4, -4, -1, 0, -1, -1, -5, -5, -1, -4, -4, -3, 0, -1, -5, -4, -4, 4, 0, -2, -6},
{-1, 0, -1, 1, -5, 4, 4, -3, 0, -4, -4, 1, -2, -4, -2, -1, -1, -4, -3, -3, 0, 4, -1, -6},
{-1, -2, -2, -2, -3, -1, -1, -2, -2, -2, -2, -1, -1, -2, -2, -1, -1, -3, -2, -1, -2, -1, -2, -6},
{-6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, 1}};


blosum_matrix_t blosum90 = {
{5, -2, -2, -3, -1, -1, -1, 0, -2, -2, -2, -1, -2, -3, -1, 1, 0, -4, -3, -1, -2, -1, -1, -6},
{-2, 6, -1, -3, -5, 1, -1, -3, 0, -4, -3, 2, -2, -4, -3, -1, -2, -4, -3, -3, -2, 0, -2, -6},
{-2, -1, 7, 1, -4, 0, -1, -1, 0, -4, -4, 0, -3, -4, -3, 0, 0, -5, -3, -4, 4, -1, -2, -6},
{-3, -3, 1, 7, -5, -1, 1, -2, -2, -5, -5, -1, -4, -5, -3, -1, -2, -6, -4, -5, 4, 0, -2, -6},
{-1, -5, -4, -5, 9, -4, -6, -4, -5, -2, -2, -4, -2, -3, -4, -2, -2, -4, -4, -2, -4, -5, -3, -6},
{-1, 1, 0, -1, -4, 7, 2, -3, 1, -4, -3, 1, 0, -4, -2, -1, -1, -3, -3, -3, -1, 4, -1, -6},
{-1, -1, -1, 1, -6, 2, 6, -3, -1, -4, -4, 0, -3, -5, -2, -1, -1, -5, -4, -3, 0, 4, -2, -6},
{0, -3, -1, -2, -4, -3, -3, 6, -3, -5, -5, -2, -4, -5, -3, -1, -3, -4, -5, -5, -2, -3, -2, -6},
{-2, 0, 0, -2, -5, 1, -1, -3, 8, -4, -4, -1, -3, -2, -3, -2, -2, -3, 1, -4, -1, 0, -2, -6},
{-2, -4, -4, -5, -2, -4, -4, -5, -4, 5, 1, -4, 1, -1, -4, -3, -1, -4, -2, 3, -5, -4, -2, -6},
{-2, -3, -4, -5, -2, -3, -4, -5, -4, 1, 5, -3, 2, 0, -4, -3, -2, -3, -2, 0, -5, -4, -2, -6},
{-1, 2, 0, -1, -4, 1, 0, -2, -1, -4, -3, 6, -2, -4, -2, -1, -1, -5, -3, -3, -1, 1, -1, -6},
{-2, -2, -3, -4, -2, 0, -3, -4, -3, 1, 2, -2, 7, -1, -3, -2, -1, -2, -2, 0, -4, -2, -1, -6},
{-3, -4, -4, -5, -3, -4, -5, -5, -2, -1, 0, -4, -1, 7, -4, -3, -3, 0, 3, -2, -4, -4, -2, -6},
{-1, -3, -3, -3, -4, -2, -2, -3, -3, -4, -4, -2, -3, -4, 8, -2, -2, -5, -4, -3, -3, -2, -2, -6},
{1, -1, 0, -1, -2, -1, -1, -1, -2, -3, -3, -1, -2, -3, -2, 5, 1, -4, -3, -2, 0, -1, -1, -6},
{0, -2, 0, -2, -2, -1, -1, -3, -2, -1, -2, -1, -1, -3, -2, 1, 6, -4, -2, -1, -1, -1, -1, -6},
{-4, -4, -5, -6, -4, -3, -5, -4, -3, -4, -3, -5, -2, 0, -5, -4, -4, 11, 2, -3, -6, -4, -3, -6},
{-3, -3, -3, -4, -4, -3, -4, -5, 1, -2, -2, -3, -2, 3, -4, -3, -2, 2, 8, -3, -4, -3, -2, -6},
{-1, -3, -4, -5, -2, -3, -3, -5, -4, 3, 0, -3, 0, -2, -3, -2, -1, -3, -3, 5, -4, -3, -2, -6},
{-2, -2, 4, 4, -4, -1, 0, -2, -1, -5, -5, -1, -4, -4, -3, 0, -1, -6, -4, -4, 4, 0, -2, -6},
{-1, 0, -1, 0, -5, 4, 4, -3, 0, -4, -4, 1, -2, -4, -2, -1, -1, -4, -3, -3, 0, 4, -1, -6},
{-1, -2, -2, -2, -3, -1, -2, -2, -2, -2, -2, -1, -1, -2, -2, -1, -1, -3, -2, -2, -2, -1, -2, -6},
{-6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6, 1}};
