/*
Copyright or © or CCopr. INRIA : Arnaud FONTAINE

arnaud.fontaine@lifl.fr

This software is a computer program whose purpose is to predict 
significantly conserved protein coding sequences and/or RNA structure 
on a set of unaligned nucleic sequences.

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

#ifndef __ARNICA_MY_NEEDLEP_MATRICES_H
#define __ARNICA_MY_NEEDLEP_MATRICES_H



#define GET_AA_INDICE(Aa,Ii)			\
   switch(Aa) {					\
   case 'A':					\
   case 'a':					\
      (Ii) = 0;					\
      break;					\
   case 'R':					\
   case 'r':					\
      (Ii) = 1;					\
      break;					\
   case 'N':					\
   case 'n':					\
      (Ii) = 2;					\
      break;					\
   case 'D':					\
   case 'd':					\
      (Ii) = 3;					\
      break;					\
   case 'C':					\
   case 'c':					\
      (Ii) = 4;					\
      break;					\
   case 'Q':					\
   case 'q':					\
      (Ii) = 5;					\
      break;					\
   case 'E':					\
   case 'e':					\
      (Ii) = 6;					\
      break;					\
   case 'G':					\
   case 'g':					\
      (Ii) = 7;					\
      break;					\
   case 'H':					\
   case 'h':					\
      (Ii) = 8;					\
      break;					\
   case 'I':					\
   case 'i':					\
      (Ii) = 9;					\
      break;					\
   case 'L':					\
   case 'l':					\
      (Ii) = 10;				\
      break;					\
   case 'K':					\
   case 'k':					\
      (Ii) = 11;				\
      break;					\
   case 'M':					\
   case 'm':					\
      (Ii) = 12;				\
      break;					\
   case 'F':					\
   case 'f':					\
      (Ii) = 13;				\
      break;					\
   case 'P':					\
   case 'p':					\
      (Ii) = 14;				\
      break;					\
   case 'S':					\
   case 's':					\
      (Ii) = 15;				\
      break;					\
   case 'T':					\
   case 't':					\
      (Ii) = 16;				\
      break;					\
   case 'W':					\
   case 'w':					\
      (Ii) = 17;				\
      break;					\
   case 'Y':					\
   case 'y':					\
      (Ii) = 18;				\
      break;					\
   case 'V':					\
   case 'v':					\
      (Ii) = 19;				\
      break;					\
   case 'B':					\
   case 'b':					\
      (Ii) = 20;				\
      break;					\
   case 'Z':					\
   case 'z':					\
      (Ii) = 21;				\
      break;					\
   case 'X':					\
   case 'x':					\
      (Ii) = 22;                                \
      break;					\
   case '*':					\
   case 'U':					\
      (Ii) = 23;				\
      break;					\
   default:					\
      ERROR_ "unknown amino acid '%c' (ascii %i)\n !!!",(Aa), (Aa)  _ERROR; \
      (Ii) = -1;				\
      break;					\
   }


typedef int blosum_matrix_t[24][24];
typedef blosum_matrix_t *blosum_matrix;


extern
blosum_matrix_t blosumn;

extern
blosum_matrix_t blosum30;

extern
blosum_matrix_t blosum35;

extern
blosum_matrix_t blosum40;

extern
blosum_matrix_t blosum45;

extern
blosum_matrix_t blosum50;

extern
blosum_matrix_t blosum55;

extern
blosum_matrix_t blosum60;

extern
blosum_matrix_t blosum62;

extern
blosum_matrix_t blosum65;

extern
blosum_matrix_t blosum70;

extern
blosum_matrix_t blosum75;

extern
blosum_matrix_t blosum80;

extern
blosum_matrix_t blosum85;

extern
blosum_matrix_t blosum90;

#endif
