/*
Copyright or © or CCopr. INRIA : Arnaud FONTAINE

arnaud.fontaine@lifl.fr

This software is a computer program whose purpose is to predict 
significantly conserved protein coding sequences and/or RNA structure 
on a set of unaligned nucleic sequences.

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

#ifndef __ARNICA_NEEDLEP_H__
#define __ARNICA_NEEDLEP_H__

#include "sequence.h"
#include "boxes.h"
#include <stdio.h>

#define NEEDLEP_PROTEIN_REGEX2 "Score"
#define NEEDLEP_PROTEIN_SCORE_REGEX "-?[0-9]+(.[0-9]+)?"


extern int
init_needlep();

extern int
needle_protein_result(FILE* fd, float* score);


extern int
box_needlep(const sequence* seqs, const int nb_seqs, sequence** prots);


extern int
call_needlep(const sequence si, const sequence sj, float* res, const float gapopen, const float gapextend, const float identity);





#endif
