#ifndef __ARNICA_INTERFACE_H__
#define __ARNICA_INTERFACE_H__

#include <stdio.h>


#include "alignment.h"
#include "sequence.h"
#include "buffer.h"



#define yytext proteatext

/* Displays warning and increase the current number of warnings */
#define proteawarning(s) (proteawarning_token(s, yytext))
/* Displays error and increase the current number of errors */
#define proteaerror(s) (proteaerror_token(s, yytext))


extern void protearestart(FILE *f);
extern int proteaparse();


extern int protealineno;
extern char* proteatext;
extern int protealex();
extern FILE *proteain;
extern char *protea_file_name;
extern int protea_nb_errors;
extern sequence* protea_result;

/* Convenient warnings */
extern void
proteawarning_token(const char *s, const char *token);

/* Convenient errors */
extern void
proteaerror_token(const char *s, const char *token);





#endif
