/*
Copyright or © or CCopr. INRIA : Arnaud FONTAINE

arnaud.fontaine@lifl.fr

This software is a computer program whose purpose is to predict 
significantly conserved protein coding sequences and/or RNA structure 
on a set of unaligned nucleic sequences.

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

#ifndef __ARNICA_STACK_H__
#define __ARNICA_STACK_H__


typedef struct {
   int *elements;
   int size;
   int max_size;
} int_stack_t;

typedef int_stack_t* int_stack;


#define STACK_IS_EMPTY(St) ((St)->size <= 0)
#define STACK_IS_FULL(St) ((St)->size == (St)->max_size)

#define STACK_VALUE_AT(St,In) ((St)->elements[In])
#define STACK_PEEK(St) ((St)->elements[(St)->size - 1])
#define STACK_POP(St) ((St)->elements[--((St)->size)])
#define STACK_PUSH(St,Val) ((St)->elements[((St)->size)++] = Val)

#define STACK_SIZE(St) ((St)->size)

#define STACK_EMPTY(St) ((St)->size = 0)

#define DESTROY_STACK(St)			\
   DESTROY((St)->elements);			\
   DESTROY(St)

#define NEW_INT_STACK(St,MSiz)			\
   NEW((St), int_stack_t, 1);			\
   NEW(((St)->elements), int, (MSiz));		\
   (St)->size=0;				\
   (St)->max_size=MSiz


extern int_stack reverse_int_stack(int_stack s);

#endif
